import tkinter as tk
from tkinter import filedialog
import cv2
import os

def select_image():
    root = tk.Tk()
    root.withdraw() 
    
    # display dialog box to open image and get file path
    filename = filedialog.askopenfilename()
    print(f"Selected file: {filename}")
    return filename

#function to retrieve image resolution
def get_res(path):
    img = cv2.imread(path)
    height, width, _ = img.shape
    
    # Construct the output path dynamically
    script_dir = os.path.dirname(os.path.abspath(__file__))
    output_dir = os.path.join(script_dir, "..", "edgenet-360", "Data", "Input")
    os.makedirs(output_dir, exist_ok=True)
    output_path = os.path.join(output_dir, "rgb.png")
    
    cv2.imwrite(output_path, img)
    print(f"RGB image saved to: {output_path}")

    return height, width

# selected_image_path = select_image()
# print("Selected Image Path:", selected_image_path)
# print("resolution:", get_res(selected_image_path))